麻豆小视频在线观看_中文黄色一级片_久久久成人精品_成片免费观看视频大全_午夜精品久久久久久久99热浪潮_成人一区二区三区四区

首頁 > 開發(fā) > Linux Shell > 正文

linux shell命令行選項(xiàng)與參數(shù)用法詳解

2020-07-27 19:17:35
字體:
供稿:網(wǎng)友
問題描述:在linux shell中如何處理tail -n 10 access.log這樣的命令行選項(xiàng)?
在bash中,可以用以下三種方式來處理命令行參數(shù),每種方式都有自己的應(yīng)用場景。
1,直接處理,依次對$1,$2,...,$n進(jìn)行解析,分別手工處理;
2,getopts來處理,單個(gè)字符選項(xiàng)的情況(如:-n 10 -f file.txt等選項(xiàng));
3,getopt,可以處理單個(gè)字符選項(xiàng),也可以處理長選項(xiàng)long-option(如:--prefix=/home等)。
總結(jié):小腳本手工處理即可,getopts能處理絕大多數(shù)的情況,getopt較復(fù)雜、功能也更強(qiáng)大。
1,直接手工處理位置參數(shù)
必須要要知道幾個(gè)變量,
復(fù)制代碼 代碼如下:

   *    $0 :即命令本身,相當(dāng)于c/c++中的argv[0]
    *    $1 :第一個(gè)參數(shù).
    *    $2, $3, $4 ... :第2、3、4個(gè)參數(shù),依次類推。
    *    $#  參數(shù)的個(gè)數(shù),不包括命令本身
    *    $@ :參數(shù)本身的列表,也不包括命令本身
    *    $* :和$@相同,但"$*" 和 "$@"(加引號)并不同,"$*"將所有的參數(shù)解釋成一個(gè)字符串,而"$@"是一個(gè)參數(shù)數(shù)組。

手工處理方式能滿足多數(shù)的簡單需求,配合shift使用也能構(gòu)造出強(qiáng)大的功能,但處理復(fù)雜選項(xiàng)時(shí)建議用下面的兩種方法。
例子,(getargs.sh):

復(fù)制代碼 代碼如下:

#!/bin/bash
if [ $# -lt 1 ]; then
    echo "error.. need args"
    exit 1
fi
echo "commond is $0"
echo "args are:"
for arg in "$@"
do
    echo $arg
done


運(yùn)行命令:

復(fù)制代碼 代碼如下:

./getargs.sh 11 22 cc
commond is ./getargs.sh
args are:
11
22
cc

2,getopts (shell內(nèi)置命令)
處理命令行參數(shù)是一個(gè)相似而又復(fù)雜的事情,為此,c提供了getopt/getopt_long等函數(shù),c++的boost提供了options庫,在shell中,處理此事的是getopts和getopt。
getopts/getopt的區(qū)別,getopt是個(gè)外部binary文件,而getopts是shell builtin。

復(fù)制代碼 代碼如下:

[root@jbxue ~]$ type getopt
getopt is /usr/bin/getopt
[root@jbxue ~]$ type getopts
getopts is a shell builtin

getopts不能直接處理長的選項(xiàng)(如:--prefix=/home等)
關(guān)于getopts的使用方法,可以man bash  搜索getopts
getopts有兩個(gè)參數(shù),第一個(gè)參數(shù)是一個(gè)字符串,包括字符和“:”,每一個(gè)字符都是一個(gè)有效的選項(xiàng),如果字符后面帶有“:”,表示這個(gè)字符有自己的參數(shù)。getopts從命令中獲取這些參數(shù),并且刪去了“-”,并將其賦值在第二個(gè)參數(shù)中,如果帶有自己參數(shù),這個(gè)參數(shù)賦值在“optarg”中。提供getopts的shell內(nèi)置了optarg這個(gè)變變,getopts修改了這個(gè)變量。
這里變量$optarg存儲相應(yīng)選項(xiàng)的參數(shù),而$optind總是存儲原始$*中下一個(gè)要處理的元素位置。
while getopts ":a:bc" opt  #第一個(gè)冒號表示忽略錯(cuò)誤;字符后面的冒號表示該選項(xiàng)必須有自己的參數(shù)
例子,(getopts.sh):

復(fù)制代碼 代碼如下:

echo $*
while getopts ":a:bc" opt
do
        case $opt in
                a ) echo $optarg
                    echo $optind;;
                b ) echo "b $optind";;
                c ) echo "c $optind";;
                ? ) echo "error"
                    exit 1;;
        esac
done
echo $optind
shift $(($optind - 1))
#通過shift $(($optind - 1))的處理,$*中就只保留了除去選項(xiàng)內(nèi)容的參數(shù),可以在其后進(jìn)行正常的shell編程處理了。
echo $0
echo $*


執(zhí)行命令:

復(fù)制代碼 代碼如下:

./getopts.sh -a 11 -b -c
-a 11 -b -c
11
3
b 4
c 5
5
./getopts.sh

3,getopt(一個(gè)外部工具)
具體用用法可以 man getopt
#-o表示短選項(xiàng),兩個(gè)冒號表示該選項(xiàng)有一個(gè)可選參數(shù),可選參數(shù)必須緊貼選項(xiàng),如-carg 而不能是-c arg
#--long表示長選項(xiàng)
例子,(getopt.sh):

復(fù)制代碼 代碼如下:

#!/bin/bash
# a small example program for using the new getopt(1) program.
# this program will only work with bash(1)
# an similar program using the tcsh(1) script. language can be found
# as parse.tcsh
# example input and output (from the bash prompt):
# ./parse.bash -a par1 'another arg' --c-long 'wow!*/?' -cmore -b " very long "
# option a
# option c, no argument
# option c, argument `more'
# option b, argument ` very long '
# remaining arguments:
# --> `par1'
# --> `another arg'
# --> `wow!*/?'
# note that we use `"$@"' to let each command-line parameter expand to a
# separate word. the quotes around `$@' are essential!
# we need temp as the `eval set --' would nuke the return value of getopt.
#-o表示短選項(xiàng),兩個(gè)冒號表示該選項(xiàng)有一個(gè)可選參數(shù),可選參數(shù)必須緊貼選項(xiàng)
#如-carg 而不能是-c arg
#--long表示長選項(xiàng)
#"$@"在上面解釋過
# -n:出錯(cuò)時(shí)的信息
# -- :舉一個(gè)例子比較好理解:
#我們要?jiǎng)?chuàng)建一個(gè)名字為 "-f"的目錄你會怎么辦?
# mkdir -f #不成功,因?yàn)?f會被mkdir當(dāng)作選項(xiàng)來解析,這時(shí)就可以使用
# mkdir -- -f 這樣-f就不會被作為選項(xiàng)。
temp=`getopt -o ab:c:: --long a-long,b-long:,c-long:: /
     -n 'example.bash' -- "$@"`
if [ $? != 0 ] ; then echo "terminating..." >&2 ; exit 1 ; fi
# note the quotes around `$temp': they are essential!
#set 會重新排列參數(shù)的順序,也就是改變$1,$2...$n的值,這些值在getopt中重新排列過了
eval set -- "$temp"
#經(jīng)過getopt的處理,下面處理具體選項(xiàng)。
while true ; do
        case "$1" in
                -a|--a-long) echo "option a" ; shift ;;
                -b|--b-long) echo "option b, argument /`$2'" ; shift 2 ;;
                -c|--c-long)
                        # c has an optional argument. as we are in quoted mode,
                        # an empty parameter will be generated if its optional
                        # argument is not found.
                        case "$2" in
                                "") echo "option c, no argument"; shift 2 ;;
                                *)  echo "option c, argument /`$2'" ; shift 2 ;;
                        esac ;;
                --) shift ; break ;;
                *) echo "internal error!" ; exit 1 ;;
        esac
done
echo "remaining arguments:"
for arg do
   echo '--> '"/`$arg'" ;
done

運(yùn)行命令:
復(fù)制代碼 代碼如下:

./getopt.sh --b-long abc -a -c33 remain
option b, argument `abc'
option a
option c, argument `33'
remaining arguments:
--> `remain'

以上就是有關(guān)linux shell命令行選項(xiàng)與參數(shù)用法的詳細(xì)內(nèi)容,希望對大家有所幫助。
發(fā)表評論 共有條評論
用戶名: 密碼:
驗(yàn)證碼: 匿名發(fā)表
主站蜘蛛池模板: 黄色大片在线观看 | 色av综合在线 | 成人做爰www免费看 欧美精品免费一区二区三区 | 黄色电影免费提供 | 久久精品爱 | 免费一级欧美大片视频在线 | 免费成人 | 欧美一级电影网 | 最近中文字幕一区二区 | av最新在线观看 | cosplay裸体福利写真 | 久久久久久久一区 | 国产精品自拍99 | 国产日韩线路一线路二 | 99re热视频这里只精品 | 九九热在线精品视频 | 欧美伦交 | 久久久久久久一区二区三区 | 成人在线观看一区二区三区 | 一本精品999爽爽久久久 | 亚洲激情91 | 午夜视频在线观看91 | 欧美日韩一区三区 | 天海翼无删减av三级在线观看 | 136福利视频 | 美女又黄又www | 一本色道久久综合狠狠躁篇适合什么人看 | 爽爽视频免费看 | 国产羞羞网站 | 亚洲人成免费 | 久久97超碰 | 日韩视频一区在线 | 鲁丝一区二区三区不属 | 亚洲视频观看 | 羞羞视频免费网站入口 | 久久老司机 | 成人午夜视频网站 | 国产精品久久久久久238 | hdjapanesemassagehd日本 | 毛片国产 | 亚洲一区 国产 |